###############################################################################

module HelmWrapper

###############################################################################

  module Tasks

###############################################################################

    class Validate < ::Rake::TaskLib

###############################################################################

      include HelmWrapper::Shared::Logging

###############################################################################

      @binary
      @chart

###############################################################################

      def initialize(binary:, chart:)
        @binary = binary
        @chart  = chart

        yield self if block_given?

        validate_task
      end

###############################################################################

      def validate_task
        desc "Validates a Helm chart stored locally."
        task :validate => :binary do |t, args|
          runner = HelmWrapper::Shared::Runner.new(binary: @binary, chart: @chart)

          logger.info("Running Helm validate for path: #{@chart.path}...")

          runner.lint
        end
      end

###############################################################################

    end

###############################################################################

  end

###############################################################################

end

###############################################################################
